"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.APIMiddlewareProvider = void 0;
const tslib_1 = require("tslib");
const core_1 = require("@loopback/core");
const rest_1 = require("@loopback/rest");
const keys_1 = require("../keys");
let APIMiddlewareProvider = class APIMiddlewareProvider {
    constructor(logger) {
        this.logger = logger;
    }
    async value() {
        const middleware = async (ctx, next) => {
            try {
                const requestTime = Date.now();
                const { request } = ctx;
                this.logger.logger.info(`Request ${request.method} ${request.url} started at ${requestTime.toString()}.
        Request Details
        Referer = ${request.headers.referer}
        User-Agent = ${request.headers['user-agent']}
        Remote Address = ${request.socket.remoteAddress}
        Remote Address (Proxy) = ${request.headers['x-forwarded-for']}`);
                return await next();
            }
            catch (err) {
                return this.handleError(err);
            }
        };
        return middleware;
    }
    handleError(err) {
        this.logger.logger.error(`Request closed by error
    StatusCode = ${err.statusCode}
    message = ${err.message}
    error= ${JSON.stringify(err)}
    `);
        throw err;
    }
};
APIMiddlewareProvider = tslib_1.__decorate([
    (0, core_1.injectable)((0, rest_1.asMiddleware)({
        group: 'validationError',
        upstreamGroups: rest_1.RestMiddlewareGroups.SEND_RESPONSE,
        downstreamGroups: rest_1.RestMiddlewareGroups.CORS,
    })),
    tslib_1.__param(0, (0, core_1.inject)(keys_1.LoggerBindings.LOGGER)),
    tslib_1.__metadata("design:paramtypes", [Object])
], APIMiddlewareProvider);
exports.APIMiddlewareProvider = APIMiddlewareProvider;
//# sourceMappingURL=api.middleware.js.map